MAXNUMP	EQU	8	; nmero mximo de processos
TAMPILHA	EQU	100	; dimenso da pilha (em palavras) de cada processo
LEDS		EQU	8000H	; endereo do perifrico dos LEDs
ESPERA	EQU	1000	; valor de espera (depende do desempenho do
				; computador que executa o simulador)
IMAGEMRE	EQU	0300H	; valor do RE a guardar na pilha durante a criao
				; de um processo (tem de ter IE0 e IE a 1)

PLACE		1000H		; zona de dados
tabCont:	TABLE	MAXNUMP	; reserva espao para os contextos dos processos
pilha:	TABLE	800	; reserva espao para as pilhas dos processos
				; (MAXNUMP * TAMPILHA)
pilhaPP:	TABLE	30	; pilha para o programa principal
fimPilhaPP:			; valor de inicializao do SP do prog. principal
numP:		WORD	0	; nmero actual de processos
valorLEDs:	WORD	0	; imagem na memria do valor dos LEDs

tabInt:	WORD	Despacho ; tabela de excepes (s tem INT0)

trinco:	WORD	0	; varivel para excluso mtua

PLACE		0000H		; programa principal, inicializaes, etc.
incio:
	MOV	BTE, tabInt	; inicializa BTE com tabela de excepes
	MOV	SP, fimPilhaPP	; inicializa SP com pilha do programa principal
	MOV	R0, 0
	MOV	R1, trinco
	MOV	[R1], R0	; inicializa varivel de excluso mtua
	MOV	R0, 0
	MOV	R1, numP
	MOV	[R1], R0	; inicializa nmero actual de processos
	MOV	RPID, R0	; inicializa nmero do processo a correr
	MOV	R1, valorLEDs
	MOV	[R1], R0	; inicializa imagem na memria do valor dos LEDs
	MOV	R0, Pisca	; endereo do processo que pisca o LED 0
	CALL	CriaProc	; cria o processo
	MOV	R0, Alterna	; endereo do processo que alterna os LEDs
	CALL	CriaProc	; cria o processo
	MOV	R0, tabCont	; tabela dos contextos
	MOV	SP, [R0]	; recupera SP do primeiro processo
	POPC			; restaura todos os registos (excepto PC e RE, que						; tinham sido salvos aparte, SP, BTE e TEMP)
	RFE			; retorna para o primeiro processo (o outro ser 
				; invocado pelo mecanismo do despacho). Esta
				; instruo liga os bits das interrupes devido
				; ao valor de RE pre-guardado na pilha durante
				; a criao do processo	
; processo que pisca o LED 0
Pisca:
	MOV	R1, valorLEDs	; imagem na memria do valor dos LEDs
	MOV	R2, LEDS	; endereo do perifrico dos LEDs
ciclo0:
	CALL	Entrar	; espera at entrar na seco crtica
	MOV	R3, [R1]	; l imagem na memria do valor dos LEDs
	CPL	R3, 0		; troca o bit 0 (LED deste processo)
	MOV	[R1],	R3 	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R2],	R3 	; actualiza valor dos LEDs no perifrico
	CALL	Sair		; liberta a seco crtica
	MOV	R0, ESPERA	; valor de espera
	CALL	Espera	; rotina que espera um tempo
	JMP	ciclo0	; continua o ciclo

; processo que liga alternadamente os LEDs 2 e 3
Alterna:
	MOV	R1, valorLEDs	; imagem na memria do valor dos LEDs
	MOV	R2, LEDS	; endereo do perifrico dos LEDs
ciclo1:
	CALL	Entrar	; espera at entrar na seco crtica
	MOV	R3, [R1]	; l imagem na memria do valor dos LEDs
	CPL	R3, 2		; troca o LED 2
	BIT	R3, 2		; v estado do LED 2 para o bit 3 ficar ao contrrio
	JZ	bit1		; se o LED 2 est a 0...
	CLR	R3, 3		; seno, coloca-o a 0
	JMP	altera
bit1:	SET	R3, 3		; ... coloca o bit 3 a 1
altera:
	MOV	[R1], R3 	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R2], R3 	; actualiza valor dos LEDs no perifrico
	CALL	Sair		; liberta a seco crtica
	MOV	R0, ESPERA	; valor de espera
	CALL	Espera	; rotina que espera um tempo
	JMP	ciclo1	; continua o ciclo

; rotina que espera algum tempo por meio de um ciclo. Recebe em R0 o nmero
; de iteraes a esperar
Espera:
	SUB	R0, 1		; menos uma iterao para esperar
	JNZ	Espera	; executa ciclo at R0 chegar a 0
	RET

; rotina que cria um processo. No R0 recebe o endereo de entrada do processo 
; (da sua primeira instruo). Na imagem de R0 guardada na pilha do novo
; processo fica o seu nmero do processo.
CriaProc:
	PUSH	R1		; guarda registos usados
	PUSH	R2
	PUSH	R3
	MOV	R1, numP	
	MOV	R2, [R1]	; nmero actual de processos
	ADD	R2, 1		; passa a haver mais um processo
	MOV	R3, MAXNUMP	; nmero mximo de processos
	CMP	R2, R3
	JGE	fim		; se j no pode criar mais processos, retorna
	MOV	[R1], R2 	; actualiza o nmero actual de processos
	MOV	R3, TAMPILHA	; tamanho da pilha de cada processo em palavras
	MUL	R3, R2		; espao de pilha ocupado por todos os processos
	SHL	R3, 1		; espao de pilha em bytes
	MOV	R1, pilha	; base das pilhas dos processos
	ADD	R1, R3		; endereo logo aps a pilha do novo processo
	SUB	R1, 2		; primeira palavra til da pilha deste processo
	MOV	[R1], R0	; coloca l o endereo do processo
	SUB	R1, 2		; palavra seguinte da pilha deste processo
	MOV	R0, IMAGEMRE	; valor de RE com interrupes permitidas
	MOV	[R1], R0	; coloca esse valor de RE na pilha
	MOV	R3, 24	; reserva espao necessrio para 12 registos 
	SUB	R1, R3	; principais (todos excepto RE, TEMP, BTE e SP)
	MOV	R3, tabCont	; base da tabela dos contextos
	SUB	R2, 1		; nmero do processo actual (n. de processos  1)
	SHL	R2, 1		; multiplica n. de processos por 2
	ADD	R3, R2	; endereo na tabela do contexto deste processo
	MOV	[R3], R1	; coloca l o valor do SP deste processo			
fim:	POP	R3		; restaura o valor dos registos
	POP	R2
	POP	R1	
	RET

; rotina de interrupo de fatia de tempo (INT0)
Despacho:							
	PUSHC			; guarda todos os registos (excepto PC e RE, que
				; j foram salvos pela invocao da rotina, SP,
				; que  guardado na tabela de contextos, TEMP e BTE)
	MOV	R0, tabCont	; base da tabela dos contextos dos processos
	MOV	R2, RPID	; nmero do processo a correr
	SHL	R2, 1		; multiplica por 2 (endereamento de byte)
	MOV	[R0+R2], SP	; guarda o valor actual do SP
	MOV	R3, numP
	MOV	R4, [R3]	; nmero actual de processos
	SHR	R2, 1		; repe nmero do processo a correr
	ADD	R2, 1		; passa ao processo seguinte
	CMP	R2, R4
	JLT	prox		; se j chegou ao ltimo, ...
	MOV	R2, 0		; ...  preciso voltar ao princpio
prox:	MOV	RPID, R2	; actualiza o nmero do processo a correr
	SHL	R2, 1		; multiplica por 2 (endereamento de byte)
	MOV	SP, [R0+R2] 	; obtm o valor do SP do novo processo
	POPC			; restaura todos os registos (excepto PC e RE, que						; tinham sido salvos aparte, SP, BTE e TEMP)
	RFE			; retorna da rotina (para o novo processo)

; rotina que usa uma varivel de excluso mtua para proteger uma seco crtica ; (faz um processo esperar at conseguir entrar na seco crtica)
Entrar:
	PUSH	R0		; guarda registos
	PUSH	R1
	MOV	R0, trinco	; varivel de excluso mtua
deNovo:
	MOV	R1, 1		; valor para fechar o trinco lgico
	SWAP	R1, [R0]	; tenta fechar o trinco lgico (operao atmica)
	CMP	R1, 0		; estava aberto (valor 0)?
	JNZ	deNovo	; se estava fechado, tem de continuar  espera
	POP	R1		; conseguiu! Pode recuperar os registos...
	POP	R0
	RET			; ... e regressar

; rotina que liberta uma seco crtica
Sair:	PUSH	R0		; guarda registos
	PUSH	R1
	MOV	R0, trinco	; varivel de excluso mtua
	MOV	R1, 0		; valor para abir o trinco lgico
	MOV	[R0], R1 	; abre o trinco lgico
	POP	R1		; J est. Pode recuperar os registos...
	POP	R0
	RET			; ... e regressar
